package models

import (
	"github.com/rdlucklib/rdluck_tools/orm"
	"time"
)

type CygxPageHistoryRecord struct {
	Id                     int       `orm:"column(id);pk"`
	UserId                 int       `description:"用户ID"`
	CreateTime             time.Time `description:"创建时间"`
	Mobile                 string    `description:"手机号"`
	Email                  string    `description:"邮箱"`
	CompanyId              int       `description:"公司id"`
	CompanyName            string    `description:"公司名称"`
	DetailId               string    `description:"详情ID"`
	ChartPermissionId      int       `description:"行业ID"`
	IndustrialManagementId string    `description:"产业ID"`
	PageType               string    `description:"页面类型，纪要：Summary，纪要搜索：SummarySearch，报告：Report，报告搜索：ReportSearch，产业列表：IndustryList，活动：Activit，活动搜索：ActivitSearch，活动详情：ActivitParticulars，报告详情：ReportParticulars"`
}

type CygxPageHistoryRecordRep struct {
	DetailId               string `description:"详情ID"`
	ChartPermissionId      int    `description:"行业ID"`
	IndustrialManagementId string `description:"产业ID"`
	PageType               string `description:"页面类型，纪要：Summary，纪要搜索：SummarySearch，报告：Report，报告搜索：ReportSearch，产业列表：IndustryList，活动：Activit，活动搜索：ActivitSearch，活动详情：ActivitParticulars，报告详情：ReportParticulars , 我的日程：MySchedule, 更多标签：LabelMore ， 文章复制：ArticleCopy"`
}

//添加
func AddCygxPageHistoryRecord(item *CygxPageHistoryRecord) (lastId int64, err error) {
	o := orm.NewOrm()
	lastId, err = o.Insert(item)
	return
}
