package services

import (
	"fmt"
	"github.com/PuerkitoBio/goquery"
	"github.com/beego/beego/v2/task"
	"hongze/hongze_cygx/models"
	"hongze/hongze_cygx/utils"
	"html"
	"strconv"
	"strings"
	"time"
)

func Task() {
	fmt.Println("start")
	if utils.RunMode == "release" && utils.IsTask {
		//syncTacticsListAddreport := task.NewTask("syncTacticsListAddreport", "0 */5 * * * *", SyncTacticsListAddreport) //同步文章
		//task.AddTask("syncTacticsListAddreport", syncTacticsListAddreport)
		getSummarytoEs := task.NewTask("getSummarytoEs", "0 */30 * * * *", GetSummarytoEs) //同步纪要库内容到Es
		task.AddTask("getSummarytoEs", getSummarytoEs)
		getArticleListByApi := task.NewTask("getArticleListByApi", "0 */5 * * * *", GetArticleListByApi) //通过三方接口获取策略平台上的文章
		task.AddTask("getArticleListByApi", getArticleListByApi)
		//会议提醒模板消息推送
		sendActivityBeginMsg := task.NewTask("sendActivityBeginMsg", "0 */10 8-22 * * *", SendActivityBeginMsg) //会议前60分钟的提醒
		task.AddTask("sendActivityBeginMsg", sendActivityBeginMsg)
		sendActivityBeginMsgMeeting := task.NewTask("sendActivityBeginMsgMeeting", "0 */5 8-22 * * *", SendActivityBeginMsgMeeting) //会议前15分钟的提醒
		task.AddTask("sendActivityBeginMsgMeeting", sendActivityBeginMsgMeeting)

		//预约外呼名单，会前1小时自动发送邮件给专家组
		sendEmailFileToExpert := task.NewTask("sendEmailFileToExpert", "0 */5 8-22 * * *", SendEmailFileToExpert) //预约外呼名单，会前1小时自动发送邮件给专家组
		task.AddTask("sendEmailFileToExpert", sendEmailFileToExpert)

		sendEmailFileForAskMsgResearch := task.NewTask("sendEmailFileForAskMsgResearch", "0 */5 8-22 * * *", SendEmailFileForAskMsgResearch) //研选系列专家电话会，会前1小时将问题列表发送给邮箱
		task.AddTask("sendEmailFileForAskMsgResearch", sendEmailFileForAskMsgResearch)

		sendEmailFileForAskMsg := task.NewTask("sendEmailFileForAskMsg", "0 */5 8-22 * * *", SendEmailFileForAskMsg) //非研选系列专家电话会，根据主持人姓名，会前15分钟将问题列表发送给至该主持人对应邮箱
		task.AddTask("sendEmailFileForAskMsg", sendEmailFileForAskMsg)

		sendEmailUserWhiteListChange := task.NewTask("sendEmailUserWhiteListChange", "0 00 17 * * *", SendEmailUserWhiteListChange) //新增 和冻结的客户白名单
		task.AddTask("sendEmailUserWhiteListChange", sendEmailUserWhiteListChange)
	}

	if utils.IsTask {
		//修改任务状
		updateActivitySattus := task.NewTask("syncTacticsListAddreport", "0 */1 8-22 * * *", UpdateActivitySattus)
		task.AddTask("updateActivitySattus", updateActivitySattus)

		//更新深 和新的标签
		updateIndustrialManagementLabel := task.NewTask("updateIndustrialManagementLabel", "0 */30 * * * *", UpdateIndustrialManagementLabel)
		task.AddTask("updateIndustrialManagementLabel", updateIndustrialManagementLabel)

		//更改对应产业的文章阅读数量
		chageIndustrialArticleNum := task.NewTask("chageIndustrialArticleNum", "0 01 00 * * *", ChageIndustrialArticleNum) //更改对应产业的文章阅读数量
		task.AddTask("chageIndustrialArticleNum", chageIndustrialArticleNum)
	}
	//ActivityAttendanceDetail()
	//SynchronizationArthistory()//同步原有的阅读记录
	//GetAddpArticle() //同步日度点评数据
	//SendEmailAllUserWithRAI()     //发送当前所有权益用户到沈大爷的邮箱
	//SendEmailAllUserWithCompany() //发送这些公司下的用户到沈大爷的邮箱
	task.StartTask()
	fmt.Println("end")
}

////白名单发送
//sendEmailUserWhiteList := task.NewTask("sendEmailUserWhiteList", "0 27 17 * * *", SendEmailUserWhiteList) //白名单发送
//task.AddTask("sendEmailUserWhiteList", sendEmailUserWhiteList)

//editOutboundMobile := task.NewTask("editOutboundMobile", "0 */1 8-22 * * *", EditOutboundMobile) //同步外呼号码与手机号
//task.AddTask("sendEmailFileToExpert", editOutboundMobile)
//editUserOutboundMobile := task.NewTask("editUserOutboundMobile", "0 27 14 * * *   ", EditUserOutboundMobile) //同步外呼号码与手机号
//task.AddTask("editUserOutboundMobile", editUserOutboundMobile)

func CreateIndex() {
	indexName := "cygx_article_v1" //utils.IndexName
	mappingJson := `{
 "mappings": {
   "dynamic": true,
   "properties": {
     "ArticleId": {
       "type": "integer"
     },
     "BodyText": {
       "type": "text",
       "term_vector": "with_positions_offsets",
		"analyzer": "ik_smart"
     },
     "PublishDate": {
       "type": "keyword"
     },
     "SubCategoryName": {
       "type": "text",
       "term_vector": "with_positions_offsets",
		"analyzer": "ik_smart"
     },
     "Title": {
       "type": "text",
       "term_vector": "with_positions_offsets",
		"analyzer": "ik_smart"
     },
     "TitleEn": {
       "type": "text",
       "term_vector": "with_positions_offsets"
     },
     "UpdateFrequency": {
       "type": "text",
       "term_vector": "with_positions_offsets"
     },
     "ExpertBackground": {
       "type": "text",
       "term_vector": "with_positions_offsets"
     }
   }
 }
}`
	EsCreateIndex(indexName, mappingJson)
	AddAllArticle()
}

func AddAllArticle() {
	endDate := time.Now().AddDate(0, 0, -30).Format(utils.FormatDate)
	//allList, err := models.GetArticleAll()
	allList, err := models.GetArticleAllDate(endDate)
	if err != nil {
		fmt.Println("GetArticleAll Err:", err.Error())
		return
	}
	indexName := utils.IndexName
	for _, v := range allList {
		content := html.UnescapeString(v.Body)
		doc, err := goquery.NewDocumentFromReader(strings.NewReader(content))
		if err != nil {
			fmt.Println("create doc err:", err.Error())
			return
		}
		bodyText := doc.Text()
		item := new(ElasticTestArticleDetail)
		item.ArticleId = v.ArticleId
		item.Title = v.Title
		item.PublishDate = v.PublishDate
		item.BodyText = bodyText
		item.ExpertBackground = v.ExpertBackground
		EsAddOrEditData(indexName, strconv.Itoa(v.ArticleId), item)
		fmt.Println(v.ArticleId)
	}
}

func AddAllArticleV4() {
	allList, err := models.GetArticleAll2()
	if err != nil {
		fmt.Println("GetArticleAll Err:", err.Error())
		return
	}

	indexName := "cygx_article_v4"

	for _, v := range allList {
		content := html.UnescapeString(v.Body)
		doc, err := goquery.NewDocumentFromReader(strings.NewReader(content))
		if err != nil {
			fmt.Println("create doc err:", err.Error())
			return
		}
		bodyText := doc.Text()

		item := new(ElasticTestArticleDetailV4)
		item.ArticleId = v.ArticleId
		item.Title = v.Title
		item.PublishDate = v.PublishDate
		item.BodyText = bodyText
		item.IsSummary = v.IsSummary
		item.IsReport = v.IsReport
		//if v.IsReport == 1 {
		//	item.IsReport = true
		//}
		//if v.IsSummary == 1 {
		//	item.IsSummary = true
		//}
		EsAddOrEditDataV4(indexName, strconv.Itoa(v.ArticleId), item)
		fmt.Println(v.ArticleId)
	}
}

// "term_vector": "with_positions_offsets"

type ElasticArticleDetail struct {
	ArticleId        int    `description:"报告id"`
	Title            string `description:"标题"`
	TitleEn          string `description:"英文标题 "`
	UpdateFrequency  string `description:"更新周期"`
	CreateDate       string `description:"创建时间"`
	PublishDate      string `description:"发布时间"`
	Abstract         string `description:"摘要"`
	CategoryName     string `description:"一级分类"`
	SubCategoryName  string `description:"二级分类"`
	InterviewDate    string `description:"访谈时间"`
	ExpertBackground string `description:"专家背景"`
	ExpertNumber     string `description:"专家编号"`
	Department       string `description:"作者"`
	ArticleIdMd5     string `description:"纪要id"`
	BodyText         string `description:"内容"`
}

type ElasticTestArticleDetail struct {
	ArticleId        int    `description:"报告id"`
	Title            string `description:"标题"`
	BodyText         string `description:"内容"`
	PublishDate      string `description:"发布时间"`
	ExpertBackground string `description:"专家背景"`
}

type ElasticTestArticleDetailV4 struct {
	ArticleId   int    `description:"报告id"`
	Title       string `description:"标题"`
	BodyText    string `description:"内容"`
	PublishDate string `description:"发布时间"`
	IsSummary   int    `description:"是否属于纪要库"`
	IsReport    int    `description:"是否属于报告"`
}

func GetAddpArticle() {
	list, err := models.GetReportList()
	for _, v := range list {
		var articleId int
		maxArticleIdArticleInfo, errMax := models.GetMaxArticleIdInfo()
		if errMax != nil {
			fmt.Println(errMax)
			return
		}
		articleId = maxArticleIdArticleInfo.ArticleId + 1
		item := new(models.CygxArticle)
		item.Title = v.Title
		item.ArticleId = articleId
		item.SellerAndMobile = v.Author
		item.PublishDate = v.PublishTime
		item.Abstract = v.Abstract
		item.Body = html.UnescapeString(v.Content)
		item.BodyText, _ = GetReportContentTextSub(v.Content)
		item.IsReport = 1
		item.Source = 1
		item.ArticleIdMd5 = utils.MD5(strconv.Itoa(articleId))
		item.Department = "弘则产品组"
		item.ArticleType = "lyjh"
		item.IsClass = 1
		item.CreateDate = v.CreateTime
		item.UpdateFrequency = "unknow"

		item.CategoryId = 100 // 100是路演精华对应ID
		item.SubCategoryName = "路演精华"
		item.HavePublish = 1
		item.PublishStatus = 1
		item.Periods = strconv.Itoa(v.Stage)
		item.VideoUrl = v.VideoUrl
		item.VideoName = v.VideoName
		item.VideoPlaySeconds = v.VideoPlaySeconds
		newId, _ := models.AddCygxArticles(item)
		fmt.Println(articleId)
		fmt.Println(newId)
		fmt.Println(item.ArticleIdMd5)
	}
	fmt.Println(err)
	fmt.Println(list)

}

func SynchronizationArthistory() {
	go SynchronizationArtclehistory()
}
